/* $Header: /plx/source/Xclients/generic/RCS/prototypes.h,v 1.8 1996/01/30 20:34:54 lovvik Exp $ */

/*
 *   Copyright (c) 1995 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Paul Lovvik
 */

/* $Log: prototypes.h,v $
 * Revision 1.8  1996/01/30  20:34:54  lovvik
 *   Added prototypes for XVideoCard(),
 *   RTVSetFirstValidFrame(), RTVSetLastValidFrame(),
 *   and RTVUseOriginalMovieLength().
 *
 * Revision 1.7  1996/01/11  18:08:49  lovvik
 *   Removed function prototypes for output under the
 *   'callbacks.c' section.  Added prototypes for StartOutput(),
 *   StopOutput(), GetOutputParameters(), and SetOutputParameters().
 *
 * Revision 1.6  1996/01/04  17:59:42  lovvik
 * Added prototypes for StartOutput() and StopOutput().
 *
 * Revision 1.5  1995/12/14  17:28:10  lovvik
 * Added a function prototype for CreateBWLogoPixmap().
 *
 * Revision 1.4  1995/11/15  02:59:58  lovvik
 * Added prototypes for WMDeleteWindowCallback() and CatchSignals().
 *
 * Revision 1.3  1995/11/01  02:43:04  lovvik
 * Removed bandwidth from GetServerStatus().  Also, added prototypes for:
 * PauseAudioSignalHandler() and ResumeAudioSignalHandler().
 *
 * Revision 1.2  1995/10/12  20:28:35  lovvik
 * Modified the prototypes for:  SetBandwidth() and RTVGetServerStatus().
 *
 * Revision 1.1  1995/10/02  23:46:05  lovvik
 * Initial revision
 * */

static char movieToolProtosRcsid[] = "$Header: /plx/source/Xclients/generic/RCS/prototypes.h,v 1.8 1996/01/30 20:34:54 lovvik Exp $";


/* Prototypes for mainDialog.c */

void InitializeMovieTool(void);
Boolean PostInitializeWorkProc(XtPointer);
int GetMovieToolStatus(void);
void SetMovieToolStatus(int);
int GetLiveVideoStatus(void);
void SetLiveVideoStatus(int);
int GetMovieLoaded(void);
void SetMovieLoaded(int);
char *GetMovieFileName(void);
void SetMovieFileName(char *);
int GetMovieLengthInFrames(void);
void SetMovieLengthInFrames(int);
int GetFramesPerSecond(void);
void SetFramesPerSecond(int);
int GetCurrentFrame(void);
void SetCurrentFrame(int);
void SetCurrentFrameNoDisplay(int);
void SynchronizeFrames(void);
void SetCurrentFrameWithSlider(int);
int GetOutputStatus(void);
void SetOutputStatus(int);
int GetInputStatus(void);
void SetInputStatus(int);
int GetOutputAvailable(void);
void SetOutputAvailable(int);
void GetInputParameters(InputParameters *);
void SetInputParameters(InputParameters *);
void GetOutputParameters(OutputParameters *outputParameters);
void SetOutputParameters(OutputParameters *outputParameters);
int GetInputWidth(void);
void SetInputWidth(int);
int GetInputHeight(void);
void SetInputHeight(int);
void SetMovieToolTitle(void);
void GetLiveVideoSize(int *, int *);
void SetLiveVideoSize(int, int, int);
void GetCurrentMovieSize(int *, int *);
void SetCurrentMovieSize(int, int);
int GetMode(void);
void SetMode(int mode);
void RefreshCurrentFrame(void);
void SetImageFormat(char *);
char* GetImageFormat(void);


/* Prototypes for callbacks.c */

void ShowOpenFileDialog (Widget, XtPointer, XtPointer);
void SaveMovie(Widget, XtPointer, XtPointer);
void SaveStill(Widget, XtPointer, XtPointer);
void ShowSaveFileDialog (Widget, XtPointer, XtPointer);
Boolean QuitWorkProc(XtPointer);
void Quit (Widget, XtPointer, XtPointer);
void PlusButtonCallback (Widget, XtPointer, XtPointer);
void HoursTextFieldCallback (Widget, XtPointer, XtPointer);
void MinusButtonCallback (Widget, XtPointer, XtPointer);
void MinutesTextFieldCallback (Widget, XtPointer, XtPointer);
void SecondsTextFieldCallback (Widget, XtPointer, XtPointer);
void FramesTextFieldCallback (Widget, XtPointer, XtPointer);
void Search (Widget, XtPointer, XtPointer);
Boolean RecordWorkProc(XtPointer);
void Record (Widget, XtPointer, XtPointer);
void Pause (Widget, XtPointer, XtPointer);
Boolean PlayWorkProc(XtPointer);
void Play (Widget, XtPointer, XtPointer);
void Stop (Widget, XtPointer, XtPointer);
void StartOfMovie (Widget, XtPointer, XtPointer);
void ReverseFrame (Widget, XtPointer, XtPointer);
void AdvanceFrame (Widget, XtPointer, XtPointer);
void EndOfMovie (Widget, XtPointer, XtPointer);
void BrightnessAdjust (Widget, XtPointer, XtPointer);
void ContrastAdjust (Widget, XtPointer, XtPointer);
void HueAdjust (Widget, XtPointer, XtPointer);
void SaturationAdjust (Widget, XtPointer, XtPointer);
void InputSettingsDefaultPressed (Widget, XtPointer, XtPointer);
void ChangePlaybackVolume (Widget, XtPointer, XtPointer);
void ChangeRecordVolume (Widget, XtPointer, XtPointer);
void ChangeMonitorVolume (Widget, XtPointer, XtPointer);
void ChangeAudioOutputDevice (Widget, XtPointer, XtPointer);
void UseLineInForRecording (Widget, XtPointer, XtPointer);
void UseMicForRecording (Widget, XtPointer, XtPointer);
void MonitorOn (Widget, XtPointer, XtPointer);
void MonitorOff (Widget, XtPointer, XtPointer);
void ToggleAudioOnStatus (Widget, XtPointer, XtPointer);
void OpenMovie (Widget, XtPointer, XtPointer);
void SetMovieFileFormat (Widget, XtPointer, XtPointer);
void ChangeImageQuality (Widget, XtPointer, XtPointer);
void FullSize (Widget, XtPointer, XtPointer);
void QuarterSize (Widget, XtPointer, XtPointer);
void ChangeMinimumQfactor (Widget, XtPointer, XtPointer);
void ErrorShellCancelButtonPressed (Widget, XtPointer, XtPointer);
void ErrorShellOKButtonPressed (Widget, XtPointer, XtPointer);
void ShowHelpPage (Widget, XtPointer, XtPointer);
void ClearDiagnosticMessages (Widget, XtPointer, XtPointer);
void SetFieldMode (Widget, XtPointer, XtPointer);
void SetFrameMode (Widget, XtPointer, XtPointer);
void WMDeleteWindowCallback(Widget, XtPointer, XtPointer);
void CatchSignals(void);


/* Prototypes for compression.c */

void InitializeJPEGCompressionDialog(void);
int GetBandwidth(void);
void SetBandwidth(int, int);
int GetQfactor(void);
void SetQfactor(int);
void SetCompressionSize(int, int);
int GetCompressionWidth(void);
int GetCompressionHeight(void);


/* Prototypes for sunAudio.c */

void SunAudioInitializeAudio(void);
void CheckAvailableOutputPorts(void);
void CheckAvailableInputPorts(void);
void SunAudioSignalHandler(int);
int VolumeToPercent(int);
int PercentToVolume(int);
void SunAudioSetPlayVolume(int);
void SunAudioSetRecordVolume(int);
void SunAudioSetMonitorVolume(int);
void SunAudioSetOutput(int);
void SunAudioSetInput(int);
void SunAudioMonitorOn(void);
void SunAudioMonitorOff(void);
void ResumeAudioSignalHandler(void);


/* Prototypes for audio.c */

void InitializeAudioDialog(void);
int GetOutputDevice(void);
void SetOutputDevice(int);
int GetInputDevice(void);
void SetInputDevice(int);
int GetMonitorUserSetting(void);
void SetMonitorUserSetting(int);
int GetMonitorAppSetting(void);
void SetMonitorAppSetting(int);
int GetAudioOnStatus(void);
void TurnAudioOn(void);
void TurnAudioOff(void);
int GetPlaybackVolume(void);
void SetPlaybackVolume(int);
int GetRecordVolume(void);
void SetRecordVolume(int);
int GetMonitorVolume(void);
void SetMonitorVolume(int);
void DisplayPlayVolume(int);
void DisplayRecordVolume(int);
void DisplayMonitorVolume(int);
void DisplayOutputDevice(int);
void DisplayInputDevice(int);
void UnmapSpeakerToggle(void);
void UnmapHeadphonesToggle(void);
void UnmapLineOutToggle(void);
void UnmapMicrophoneToggle(void);
void UnmapLineInToggle(void);
void SetAudioOutputOneOnly(void);
void UpdateAudioControls(void);
void SetAudioNotAvailable(void);


/* Prototypes for colorSettings.c */

void InitializeColorSettingsDialog(void);
int GetBrightness(void);
void SetBrightness(int);
int GetContrast(void);
void SetContrast(int);
int GetHue(void);
void SetHue(int);
int GetSaturation(void);
void SetSaturation(int);
void DefaultColorSettings(void);


/* Prototypes for timer.c */

void InitializeTimer(void);
void DisplayFrames(void);
void DisplaySeconds(void);
void DisplayMinutes(void);
void DisplayHours(void);
int TimeToFrames(int);
int FrameHours(int, int);
int FrameMinutes(int, int);
int FrameSeconds(int, int);
int FrameFrames(int, int);
void IncrementTimer(int);
void DecrementTimer(int);
void SetTimerCurrentFrame(int, int);
void ResetClock(void);
void PauseClock(void);
void ResumeClock(void);
int TimeForNewFrame(int);


/* Prototypes for video.c */

void InitializeVideoWidget(void);
void BuildInputMenu(void);
void ShowInput(Widget, XtPointer, XtPointer);
void ChangeInputSize(int);
void StartOutput(void);
void StopOutput(void);
Boolean OutputWorkProc(XtPointer);
void StopVideo(void);
void StartVideo(void);
void SetColorSettings(int, int, int, int);
void SetVideoBrightness(int);
void SetVideoContrast(int);
void SetVideoHue(int);
void SetVideoSaturation(int);
void ResizeVideoWindow(void);
void ResizePlaybackWindow(void);
void LockVideoWindowSize(void);
void UnlockVideoWindowSize(void);
void SetInput1ToPAL(void);
Boolean ResizeVideoWorkProc(XtPointer);
void LockPlaybackWindowSize(void);
void UnlockPlaybackWindowSize(void);
void ConfigureInputForMovie(int);
int ShowOutputOnPlayback(void);
void OutputButtonPressed (Widget w, XtPointer client_data, XtPointer xt_call_data );
Boolean XVideoCard(void);
void SaveImageFileInFormat(Display*, Window, Dimension, Dimension, char*, char*);


/* Prototypes for rtvModule.c */

void InitializeRTV(void);
int ConnectRTV(void);
int DisconnectRTV(void);
int SetRTVFileName(char *);
int SetRTVBandWidth(int);
int SetRTVQfactor(int);
int SetRTVfps(int fps);
void SetRTVPosition(int, int);
int RTVRecord(void);
int RTVPlay(void);
int RTVPause(void);
int RTVRecordPause(void);
int RTVResume(void);
int RTVRecordResume(void);
int RTVDisplayOneFrame(int, int, int);
int RTVDisplayOneFrameWithSlider(int, int);
int RTVStop(void);
int RTVOpenMovie(char *, int*, int*, int*);
char *GetHostname(void);
int GetRTVMovieLength(int *);
int RTVGetCurrentFrame(int *);
int RTVGetServerStatus(int *);
int RTVAudioOff(void);
int RTVAudioOn(void);
int RTVAudioAvailable(int *);
void RTVWindowPlayPrepare(void);
void RTVWindowRecordPrepare(void);
int RTVRecordInit(void);
void RTVSetFirstValidFrame(int);
void RTVSetLastValidFrame(int);
int RTVUseOriginalMovieLength(void);
int HandleRtvError(void);


/* Prototypes for error.c */

void PrintError(char *, int);
int GetErrorCode(void);
void ClearErrorCode(void);


/* Prototypes for help.c */

void InitializeHelp(void);
void DisableHelp(void);
int OpenHelpFile(void);
void DisplayHelp(int);
void CleanHelpLine(char *);


/* Prototypes for aboutBox.c */

void InitializeAboutBox(void);
Boolean CreateLogoWorkProc(XtPointer);
void CreateLogoPixmap(Widget);
void CreateBWLogoPixmap(Widget	parentWidget);


/* Prototypes for diagnostics.c */

void InitializeDiagnostics(void);
void PrintDiagnostics(char *);
void ClearAllDiagnosticMessages(void);

/* Prototypes for window.c */

void InitializeWindowModule(void);
void RTVWindowMovementHandler(Widget, XtPointer, XEvent*, Boolean*);
void RTVWindowExposeHandler(Widget, XtPointer, XEvent*, Boolean*);
void PositionWindows(void);
int IsPlayWindowMapped(void);
int IsRecordWindowMapped(void);



/* Prototypes for disabledFeatures.c */

void DisableNonimplementedFeatures(void);

/* Prototypes for fileUtils.c */

int FileExists(char *);
int CanRecordToFile(char *);
